import java.util.ArrayList;
import java.util.HashMap;
import java.util.Scanner;

public class Course
{
	private String name;
	private int code;
	private int units;
	private Professor prof;
	private ArrayList<StudentRecord> studentList = new ArrayList<StudentRecord>();
	private HashMap<Integer,StudentRecord> studentMap = new HashMap<Integer,StudentRecord>();
	
	public Course(String name, int code, int units){
		this.name = name;
		this.code = code;
		this.units = units;
	}
	
	public void setProf(Professor p){
		prof = p;
		p.setLesson(this);
	}
	
	public void enroll(Student s){
		StudentRecord sRecord = new StudentRecord(s);
		studentList.add(sRecord);
		studentMap.put(s.getAM(),sRecord);
	}
	
	public double getGrade(int AM){
		if (studentMap.containsKey(AM)){
			StudentRecord sRecord = studentMap.get(AM);
			return sRecord.getGrade();
		}else{
			System.out.println("Student "+ AM + " not enrolled");
			return -1;
		}
	}

	
	
	public void assignGrades(){
		System.out.println("Give grades for course "+toString());
		Scanner input = new Scanner(System.in);
		for(StudentRecord sr: studentList){
			System.out.println("Give grade for student "+ sr.getStudent().getAM() +":");
			double grade = input.nextDouble();
			sr.setGrade(grade);
			if (sr.passed()){
				sr.getStudent().addUnits(units);
			}
		}
	}
	
	public String toString(){
		return name + " " + code + "("+units + ")";
	}
	
	public void printInfo(){
		System.out.println("Course " + name +" " + code + "("+units + ")");
		//System.out.println("professor:" + prof);
		for (StudentRecord r: studentList){
			System.out.println(r);
		}
	}
}